#!/usr/bin/env python3

fin = open('fence.in', 'r')
fout = open('fence.out', 'w')

n, k = map(int, fin.readline().split())
a = sorted(map(int, fin.readline().split()))

mn, mx = 0, min([k // n] + a)
while mn < mx:
    av = (mn + mx + 1) // 2
    l = 0
    for x in a:
        l = max(l + av, x)
    if l > k:
        mx = av - 1
    else:
        mn = av

print(mn, file=fout)

